import os, fcntl
from xml.dom import minidom
from rox import filer

def set_as_wallpaper(path):
	doc = minidom.parseString("""<?xml version="1.0"?>
	<env:Envelope xmlns:env="http://www.w3.org/2001/12/soap-envelope">
	 <env:Body xmlns="http://rox.sourceforge.net/SOAP/ROX-Filer">
	  <SetBackdrop>
	   <Filename></Filename>
	   <Style>Scale</Style>
	  </SetBackdrop>
	 </env:Body>
	</env:Envelope>""")
	filename = doc.documentElement.getElementsByTagName("Filename")[0]
	filename.appendChild(doc.createTextNode(path))

	r, w = os.pipe()

	fcntl.fcntl(r, fcntl.F_SETFD, fcntl.FD_CLOEXEC)
	fcntl.fcntl(w, fcntl.F_SETFD, fcntl.FD_CLOEXEC)

	os.dup2(r, 0)
	fcntl.fcntl(0, fcntl.F_SETFD, 0)	# Keep FD open on exec
	filer.spawn_rox(('-R',))
	os.dup2(2, 1)

	os.fdopen(w, 'w').write(doc.toxml())
